//Copied from pluginmain.h from iDeaS Plugin SDK.

typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned long u32;
typedef signed char s8;
typedef signed short s16;
typedef signed long s32;
#ifdef _WIN32
typedef signed __int64 s64;
typedef unsigned __int64 u64;
#else
typedef signed long long int s64;
typedef unsigned long long int u64;
#endif

#define PIT_AUDIO              	    1	//Audio
#define PIT_VIDEO              	    2	//Video 3d & 2d
#define PIT_GRAPHICS				3
#define PIT_PAD					    4	//Input Controller
#define PIT_TOUCH					5	//Touch not implemented
#define PIT_WIFI					6	//Wifi

#define PIT_DYNAMIC            	    0x100	//The plugin is loaded only in memory when enabled otherwise it is resident.
#define PIT_NOEXCLUSIVE        	    0x200	//If enabled it doesn't exclude the other pluginses of the group.
#define PIT_HOOKBEFORE              0x400   //The plugin is a hook.
#define PIT_NOMODIFY           	    0x800	//It doesn't modify the content of the sent buffer.
#define PIT_HOOKAFTER               0x1000  //The plugin is a hook.
#define PIT_IS3D					0x2000	//It is a plugin for 3d graphics.
#define PIT_ENABLERUN		   		0x4000	//iDeaS call the function RunFunc when it's enabled.
#define PIT_NOMENU			   		0x8000	//It is not included in the menu of the group
#define PIT_NORUN   				0x10000	//
#define PIT_ISNORENDERER            0x20000	//It's a plugin for graphics.

#define PIS_ENABLE             	    0x1
#define PIS_RUN                	    0x2
#define PIS_PAUSE              	    0x4

#define PNM_ENDLINE                 0x100
#define PNM_ENDFRAME                0x200
#define PNM_ENTERVBLANK             0x300
#define PNM_SWAPLCD                 0x400
#define PNM_STARTFRAME				0x500
#define PNM_ONACTIVATEWINDOW		0x600
                  
#define PIS_RUNMASK            	    0x6
#define PIS_ENABLEMASK         	    0x1
#define PIS_NOTIFYMASK				0x0000FF00
#define PIS_NOTIFYSHIFT             0x8

#define PLUGINISENABLE(p)      	    ((p->dwState & PIS_ENABLE) && (p->dwStateMask & PIS_ENABLEMASK))
#define PLUGINISSTOP(p)        	    !(p->dwState & PIS_RUNMASK)
#define PLUGINISRUN(p)         	    ((p->dwState & PIS_RUN) && (p->dwStateMask & PIS_RUNMASK))
#define PLUGINISPAUSE(p)       	    ((p->dwState & PIS_PAUSE) && (p->dwStateMask & PIS_RUNMASK))

#ifdef _WIN32

#define EXPORT __declspec(dllexport)
#define STDCALL __stdcall

#else

#define EXPORT
#define STDCALL __attribute__ ((stdcall))

typedef int BOOL;
typedef char BYTE;
typedef short WORD;
typedef long DWORD;
typedef unsigned int UINT;

#define TRUE 1
#define FALSE 0

typedef struct _GUID
{
    DWORD Data1;
    WORD  Data2;
    WORD  Data3;
    BYTE  Data4[8];
} GUID;

#define DEFINE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
        const GUID name = \
        { l, w1, w2, { b1, b2,  b3,  b4,  b5,  b6,  b7,  b8 } }

#endif

typedef struct _get_pluginfo{
   u32 cbSize;
   u32 dwType;
   u16 wIndex;
   u16 wID;
   wchar_t* pszText;
   s32 cchTextMax;
   GUID guidID;
   u32 dwLanguageID;
   u32 lParam;
} GETPLUGININFO,*LPGETPLUGININFO;

typedef struct _set_pluginfo{
    u32 cbSize;
    u16 wIndex;
    u32 dwState;
    u32 dwStateMask;
    u32 lParam;
} SETPLUGININFO,*LPSETPLUGININFO;

typedef struct {
   void* hwndOwner;
   GETPLUGININFO info;
} SETPROPPLUGIN,*LPSETPROPPLUGIN;
